part of ui_ex;

/// 材质按钮
/// Button
extension MaterialButtonEx<T extends Widget?> on T {
  /// RawMaterialButton
  RawMaterialButton rawMaterialButton({
    Key? key,
    required void Function()? onPressed,
    void Function()? onLongPress,
    void Function(bool)? onHighlightChanged,
    MouseCursor? mouseCursor,
    TextStyle? textStyle,
    Color? fillColor,
    Color? focusColor,
    Color? hoverColor,
    Color? highlightColor,
    Color? splashColor,
    double elevation = 2.0,
    double focusElevation = 4.0,
    double hoverElevation = 4.0,
    double highlightElevation = 8.0,
    double disabledElevation = 0.0,
    EdgeInsetsGeometry padding = EdgeInsets.zero,
    VisualDensity visualDensity = VisualDensity.standard,
    BoxConstraints constraints =
        const BoxConstraints(minWidth: 88.0, minHeight: 36.0),
    ShapeBorder shape = const RoundedRectangleBorder(),
    Duration animationDuration = kThemeChangeDuration,
    Clip clipBehavior = Clip.none,
    FocusNode? focusNode,
    bool autofocus = false,
    MaterialTapTargetSize? materialTapTargetSize,
    bool enableFeedback = true,
  }) =>
      RawMaterialButton(
        key: key,
        onPressed: onPressed,
        onLongPress: onLongPress,
        onHighlightChanged: onHighlightChanged,
        mouseCursor: mouseCursor,
        textStyle: textStyle,
        fillColor: fillColor,
        focusColor: focusColor,
        hoverColor: hoverColor,
        highlightColor: highlightColor,
        splashColor: splashColor,
        elevation: elevation,
        focusElevation: focusElevation,
        hoverElevation: hoverElevation,
        highlightElevation: highlightElevation,
        disabledElevation: disabledElevation,
        padding: padding,
        visualDensity: visualDensity,
        constraints: constraints,
        shape: shape,
        animationDuration: animationDuration,
        clipBehavior: clipBehavior,
        focusNode: focusNode,
        autofocus: autofocus,
        materialTapTargetSize: materialTapTargetSize,
        child: this,
        enableFeedback: true,
      );
}
